;Instituto Politecnico Tomar
;Engenharia Informatica
;Eduardo Gomes N8390
;Nuno Fernandes N6113

;##########################################################
;##########################################################
OPENRFILE MACRO			; macro que abre um ficheiro

	  MOV AL,00H		; existente, so para leitura
	  MOV AH,3DH            ; parametro de abertura
	  LEA DX, Path       	; nome do fich. a abrir
	  INT 21H			; abre
	  MOV RFHAND,AX          ; guarda o file handle do fich.

ENDM
;##########################################################
;##########################################################
OPENWFILE MACRO			; macro que abre um ficheiro

	  MOV AL,01H		; existente, so para escrita
	  MOV AH,3DH            ; parametro de abertura
	  LEA DX, Path       	; nome do fich. a abrir
	  INT 21H			; abre
	  MOV WFHAND,AX          ; guarda o file handle do fich.

ENDM
;##########################################################
;##########################################################
CLOSERFILE MACRO			; macro para fechar o fich.
	  MOV AH,3EH		; prepara para fechar
	  MOV BX,RFHAND		; indica o file handle
	  INT 21H			; fecha
ENDM
;##########################################################
;##########################################################
CLOSEWFILE MACRO			; macro para fechar o fich.
	  MOV AH,3EH		; prepara para fechar
	  MOV BX,WFHAND		; indica o file handle
	  INT 21H			; fecha
ENDM
;##########################################################
;##########################################################
SEEK_BEG MACRO			; macro que posiciona
	  MOV AL,00H		; o file pointer do ficheiro
	  MOV AH,42H		; no principio deste
	  MOV BX,RFHAND
	  MOV CX,00H
	  MOV DX,00H
	  INT 21H			; get index
ENDM
;##########################################################
;##########################################################
CREATEFILE MACRO               ; macro para criar um fich
        MOV AH,3CH           ; parametro para criar fich
        MOV CX,00H           ; atributo de ficheiro normal
        LEA DX, Path     ; nome do fich. a criar
        INT 21H              ; interrupcao
                             ; abre ou cria fich. colocando


	MOV AL,00H		; o file pointer do ficheiro
	MOV AH,42H		; no principio deste
	MOV BX,WFHAND
	MOV CX,00H
	MOV DX,00H
	INT 21H

ENDM		     		; o tamanho a zero !!!
                             ; so deve ser usado se o fich 
				     ; nao existir


;##########################################################
;##########################################################
;##########################################################
;##########################################################

STACK   SEGMENT PARA STACK	; define o seg. de pilha
	     DB 	    64 DUP ('MYSTACK ')
STACK	  ENDS

;##########################################################
;##########################################################
MYDATA  SEGMENT PARA 'DATA'

RFHAND	dw ?			;onde  guardado o file handle do ficheiro de leitura
WFHAND	dw ?			;onde  guardado o file handle do ficheiro de escrita
Buffer	db 520 dup (?),'$$'	;onde so guardados parte do bytes do ficheiro a enviar o a receber(500bytes)
				;os dois primeiros bytes servem para o receptor saber o num de caracters lidos do ficheiro

NPart_Send dw 0			;numero de vezes necessrio enviar o array Buffer


Parts dw 0			;para saber quantas vezes j foi enviado ou recebido o Buffer




Path	db	200 dup ('$')	;caminho para a directoria onde se quer enviar o receber ficheiros
PathPos	dw	0		;para saber a posio, no array Path, onde se pode adicionar outra directoria ou ficheiro
DTA	db	50 dup (0),'$'	;usado para guardar informaao sobre um ficheiro encontrado no disco (atributo, tamanho, nome...)


;------variaveis usadas para desenhar quadrados no ecr-----

square_ini_X dw 0		;posio x onde comea a ser desenhado o quadrado
square_ini_y dw 0		;posio y onde comea a ser desenhado o quadrado
square_tam_X dw 0		;tamanho do quadrado na horizontal
square_tam_y dw 0		;tamanho do quadrado na vertical

;-----------------------------------------------------------


FileName db	15 dup (0),'$'	;nome de um ficheiro(e a variavel 'NPart_Send' nas posies 13 e 14 para envio)
Cor db	62			;usado para guardar a cor das letras
CorRect db 1			;usado para saber a cor com que se desenha os quadrados

FilePos	db 0			;usado para saber a posiao onde se encontra um ficheiro que foi selecionado

DirNum db 0			;para saber o num de directorias existentes
FileNum db 0			;para saber o num de ficheiros existentes

CountFiles db 0			;usado para contar os ficheiros j encontrados

DirStart db 0			;usado para saber qual o primeiro ficheiro a ser escrito
FileStart db 0			;usado para saber qual o primeiro directoria a ser escrito



Sel_File db 15 dup (22),'ESCOLHA O FICHEIRO A ENVIAR',15 dup (22),'$'
Rec_File db 8 dup (22),'ESCOLHA DIRECTORIA PARA RECEBER O FICHEIRO',8 dup (22),'$'
Receiving db 18 dup (22),'A RECEBER O FICHEIRO',18 dup (22),'$'
Browser db 'DRIVE   DIRECTORY         FILE$'
m_err db 'error$'
Bar db 50 dup (178),'$'
NBar db 10 dup ('$'),'$'

Sel_Mode db 15 dup (22),'ESCOLHA O MODO DO PROGRAMA',15 dup (22),'$'
About db 'Eduardo N',248,'8390',39 dup ('='),'Nuno N',248,'6113','$'
Sel1 db 'EMISSOR$'
Sel2 db 'RECEPTOR$'
Sel3 db 'SAIR$'
Close db 'Voltar ao Menu$'
Receive db 'Receber Fich.$'


MYDATA  ENDS

;##########################################################
;##########################################################
MYCODE  SEGMENT PARA 'CODE'	   ; define o segmento cod. para o MASM
;-----------------------------------------------------------------
MYPROC  PROC    FAR	         ; nome do procedimento MYPROC
	ASSUME  CS:MYCODE,DS:MYDATA,SS:STACK
	PUSH    DS		   ; guarda na pilha o SEG. DS
       	SUB     AX,AX	           ; garante zero no AX
        PUSH    AX		   ; guarda zero na pilha
	MOV	AX,MYDATA	   ; coloca em AX a posicao dos DADOS
	MOV	DS,AX		   ; coloca essa posicao no reg. DS
	MOV     ES,AX		   ; coloca essa posicao no reg. ES


	MOV CorRect,1		;escolhe cor azul para desenhar rectangulos
	CALL GetCurPath		;carrega o caminho por defeito

	CALL SetVideoMode	;inicializa modo grafico

;-------------iniciar rato-------------

	MOV AX,0	;iniciar rato
	INT 33h

	mov ax,1	;mostrar rato
	int 33h

;--------------------------------------

	CALL Menu		;chama o menu

	mov ax, 0003h		; regressa ao modo MS-DOS; com cores e definicao certas
        int 10h

	RET			;volta ao dos
MYPROC ENDP
;##########################################################
;##########################################################
;##########################################################
;##########################################################
GetCurPath PROC NEAR

;-----------------------------escreve a drive por defeito

	MOV AH,19h	;Get Default Drive 
	INT 21h
	ADD AL,65	;converter Default Drive para ASCII
	MOV Path[0],AL	;e guardar esta no caminho
	MOV Path[1],':'
	MOV Path[2],'\'
	

;-----------------------------escreve o caminho por defeito
	MOV AH,47h
	MOV DL,0
	LEA SI,Path+3	;adicionar caminho  Drive j encontrada anteriormente
	INT 21H


;-----------------------------tenta encontrar final do caminho


	LEA SI,Path      ;endereco do caminho
	CLD		;direco da procura
	MOV BX,0

Find0:
	LODSB		;avana si e carrega o valor em al
	TEST AL,AL	;Zero byte?
	JZ pos_cp	;se for foi encontrado o final do array
	INC BX		;e este  guardado em BX

JMP Find0

;-----------------------------adiciona WildCards no final do caminho

pos_cp:

cmp Path[3],0		;compara para saber se o direcorio  na raiz
jne awc
DEC BX			;se sim ento adiciona as wildcards uma posiao antes

awc:

	CALL AddWildCard	;procedimento para adicionar as wildcards

	RET

GetCurPath ENDP
;##########################################################
;##########################################################
;##########################################################
;##########################################################
AddFile PROC NEAR
;(ENTRADA)
;FileName--> Nome do Ficheiro a adicionar

;-----------------------------adiciona o ficheiro ao caminho
	
	LEA SI,FileName      	;endereco do ficheiro
	CLD			;direco da procura
	MOV BX,PathPos		;carrega posio onde deve comear a ser adicionado o ficheiro

AddCh2:

	LODSB		;avana si e carrega o valor em al
	TEST AL,AL	;verifica se  o Zero byte de final do ficheiro
	JZ pos_ad2	;vai adicionado o nome do ficheiro at se encontrar o seu final
	MOV Path[BX],AL
	INC BX

JMP AddCh2

pos_ad2:
;-----------------------------coloca 0 e '$' no final do caminho

	MOV Path[BX],0		;para o endereo poder ser lido
	MOV Path[BX+1],'$'	;para o endereo poder aparecer no ecr
	MOV PathPos,BX		;guarda posio onde acabou de escrever o ficheiro
	RET

AddFile ENDP
;##########################################################
;##########################################################
;##########################################################
;##########################################################
AddDrive PROC NEAR
;(ENTRADA)
;AL--> DRIVE(0-A,1-B,2...)

	ADD AL,65		;converter Default Drive para ASCII
	MOV Path[0],AL		;e guardar esta no caminho
	MOV Path[1],':'
	MOV BX,2
	CALL AddWildCard	;procedimento para adicionar as wildcards

	RET


AddDrive ENDP
;##########################################################
;##########################################################
AddDir PROC NEAR
;(ENTRADA)
;FileName--> Nome da directoria a adicionar

	LEA SI,FileName      	;endereco da directoria
	CLD			;direco da procura
	MOV BX,PathPos		;carrega posio onde deve comear a ser adicionada a directoria

AddCh:

	LODSB		;avana si e carrega o valor em al
	TEST AL,AL	;verifica se  o Zero byte de final do ficheiro
	JZ pos_ad	;vai adicionado o nome do ficheiro at se encontrar o seu final
	MOV Path[BX],AL
	INC BX


JMP AddCh

pos_ad:

;-----------------------------adiciona WildCards no final do caminho
	CALL AddWildCard


	RET

AddDir ENDP
;##########################################################
;##########################################################

RmDir PROC NEAR
	
	MOV BX,PathPos		;carrega posio onde deve comear a ser adicionada a directoria
	DEC BX			;recua uma posiao no caminho para no coencidir com o caracter '\'
	CMP Path[BX-1],':'	;verifica se j est na raiz
	JE UntErr		;se estiver ento no se pode voltar a uma directoria anterior

RmCh:
	DEC BX			;recua-se uma posiao at achar o inicio da directoria anterior
	CMP Path[BX],'\'	;quando se achar '\' significa que foi achado o inicio
	JE pos_rd

JMP RmCh

pos_rd:
	CALL AddWildCard	;adiciona-se as wildcards depois de achada a directoria anterior
UntErr:
	RET

RmDir ENDP

;##########################################################
;##########################################################

AddWildCard PROC NEAR
;---------------->adicionar wildcards

	MOV Path[BX],'\'	;adiciona-se o '*.*'
	MOV Path[BX+1],'*'
	MOV Path[BX+2],'.'
	MOV Path[BX+3],'*'
	MOV Path[BX+4],0	;para o endereo poder ser lido
	MOV Path[BX+5],'$'	;para o endereo poder aparecer no ecr
	INC BX			;avanca para a posio onde acabou de escrever o ficheiro
	MOV PathPos,BX		;guarda posio onde acabou de escrever o ficheiro
	RET

AddWildCard ENDP

;##########################################################
;##########################################################
;##########################################################
;##########################################################
SetVideoMode PROC NEAR

	MOV AX,12h
        INT 10h


	MOV AH,11 	; prepara configurao da palete de cores
	MOV BH,00 	; inicializa a cor de background
	MOV BL,0 	; background preto
	INT 10H

;   = 0 00 000000 black 
;   = 1 01 000001 blue 
;   = 2 02 000010 green 
;   = 3 03 000011 cyan 
;   = 4 04 000100 red 
;   = 5 05 000101 magenta 
;   =14 20 010100 brown 
;   = 7 07 000111 white 
;   =56 38 111000 dark gray 
;   =57 39 111001 light blue 
;   =58 3A 111010 light green 
;   =59 3B 111011 light cyan 
;   =60 3C 111100 light red 
;   =61 3D 111101 light magenta 
;   =62 3E 111110 yellow 
;   =63 3F 111111 bright white

	RET

SetVideoMode ENDP

;##########################################################
;##########################################################
;##########################################################
;##########################################################
Menu PROC NEAR

	CALL SetVideoMode	;inicializa modo grafico


;---------escrever intrues no ecr-------------

	MOV AH,2
	MOV BX,62
	MOV DH,3;-->COLUNA
	MOV DL,12;-->LINHA
	INT 10h

	LEA DX,Sel_Mode
	MOV AH,09h
	INT 21h

	MOV AH,2
	MOV BX,62
	MOV DH,1;-->COLUNA
	MOV DL,8;-->LINHA
	INT 10h

	LEA DX,About
	MOV AH,09h
	INT 21h

	MOV AH,2
	MOV BX,62
	MOV DH,10;-->COLUNA
	MOV DL,20;-->LINHA
	INT 10h

	LEA DX,sel1
	MOV AH,09h
	INT 21h

	MOV AH,2
	MOV BX,62
	MOV DH,13;-->COLUNA
	MOV DL,20;-->LINHA
	INT 10h

	LEA DX,sel2
	MOV AH,09h
	INT 21h

	MOV AH,2
	MOV BX,62
	MOV DH,16;-->COLUNA
	MOV DL,20;-->LINHA
	INT 10h

	LEA DX,sel3
	MOV AH,09h
	INT 21h

;---------desenhar um quadrado na posiao do emissor-------------

	mov CorRect,1
	MOV square_ini_X,150
	MOV square_ini_y,155
	MOV square_tam_X,100
	MOV square_tam_y,21
	CALL Square

;---------------mostrar o rato no ecr----------------------

	MOV AX,1
	INT 33H


CALL MenuMouse	;chama procedimento para o movimento do rato no menu


	RET
Menu ENDP
;##########################################################
;##########################################################
MenuMouse PROC NEAR

Menugetpos:


	MOV AX,3	;saber posiao do rato e condiao dos butes
	INT 33h

;-----------verifica se o rato est entre as coordenadas x dos butoes

	cmp cx,150
	jl Menugetpos
	cmp cx,250
	jg Menugetpos


;-----------verifica se o rato est entre as coordenadas y do butao 'emissor'
cmp dx,176
jg lb_sel2

cmp dx,155
jl Menugetpos



	cmp bx,1
	je Emissor_Start	;se o butao for primido inicia-se a parte do emissor

;-----------se tiver desenha um quadrado a volta deste--------------------

	mov CorRect,1

	MOV square_ini_X,150
	MOV square_ini_y,155
	MOV square_tam_X,100
	MOV square_tam_y,21
	CALL Square

	mov CorRect,0
	MOV square_ini_y,203
	CALL Square

	MOV square_ini_y,251
	CALL Square


jmp Menugetpos
Emissor_Start:
CALL IniEmissor	;iniciar emissor
CALL Menu	;voltar ao menu depois de correr o emissor




lb_sel2:
;-----------verifica se o rato est entre as coordenadas y do butao 'receptor'

cmp dx,224
jg lb_sel3

cmp dx,203
jl Menugetpos

	cmp bx,1
	je Receptor_Start	;se o butao for primido inicia-se a parte do receptor

;-----------se tiver desenha um quadrado a volta deste--------------------

	mov CorRect,1
	MOV square_ini_X,150
	MOV square_ini_y,203
	MOV square_tam_X,100
	MOV square_tam_y,21
	CALL Square

	mov CorRect,0
	MOV square_ini_y,155
	CALL Square

	MOV square_ini_y,251
	CALL Square


jmp Menugetpos
Receptor_Start:
CALL IniReceptor	;iniciar receptor
CALL Menu		;voltar ao menu depois de correr o receptor


lb_sel3:

;-----------verifica se o rato est entre as coordenadas y do butao 'sair'

cmp dx,272
jg nx

cmp dx,251
jl nx

	cmp bx,1
	je Sair		;se o butao for primido ento sai-se do programa

;-----------se tiver desenha um quadrado a volta deste--------------------

	mov CorRect,1
	MOV square_ini_X,150
	MOV square_ini_y,251
	MOV square_tam_X,100
	MOV square_tam_y,21
	CALL Square

	mov CorRect,0
	MOV square_ini_y,155
	CALL Square

	MOV square_ini_y,203
	CALL Square
nx:
jmp Menugetpos
Sair:		;sair do menu e do programa

	RET
MenuMouse ENDP
;##########################################################
;##########################################################
IniGraficMode PROC NEAR		;procedimento para desenhar o ambiente grafico

	MOV CorRect,1		;escolhe cor azul para desenhar rectangulos
	CALL GetCurPath		;carrega o caminho por defeito
	CALL SetVideoMode	;inicializa modo grafico

	SUB     AX,AX
	MOV     AH,0
	MOV     AL,11100011b  ; parametros de transmissao 9600/npar/1sbit/8bts
	MOV     DX,0
	INT     14H           ; inicializa a com 1 


;--------------INTRUCOES DE FICHEIROS-------------------

	MOV AH,2
	MOV BX,62
	MOV DH,6;-->COLUNA
	MOV DL,5;-->LINHA
	INT 10h

	LEA DX,Browser
	MOV AH,09h
	INT 21h

;--------------MENU BUTTON-------------------

	MOV AH,2
	MOV BX,62
	MOV DH,15;-->COLUNA
	MOV DL,53;-->LINHA
	INT 10h

	LEA DX,Close
	MOV AH,09h
	INT 21h

	MOV square_ini_X,418
	MOV square_ini_y,232
	MOV square_tam_X,121
	MOV square_tam_y,27
	CALL Square


;--------------BAR-------------------


	MOV square_ini_X,36
	MOV square_ini_y,412
	MOV square_tam_X,406
	MOV square_tam_y,22
	CALL Square



;--------------PATH-------------------

	MOV AH,2
	MOV BX,0
	MOV DH,23;-->COLUNA
	MOV DL,5;-->LINHA
	INT 10h
	MOV AL,'P'
	CALL WriteChar
	MOV AL,'A'
	CALL WriteChar
	MOV AL,'T'
	CALL WriteChar
	MOV AL,'H'
	CALL WriteChar
	MOV AL,':'
	CALL WriteChar

	CALL WritePath	;escreve caminho da directoria actual

;--------------DRIVES-------------------
	MOV DH,6;-->COLUNA-1
	MOV DL,6;-->LINHA
	CALL WriteDrives


	MOV square_ini_X,37
	MOV square_ini_y,110
	MOV square_tam_X,47
	MOV square_tam_y,242	;16*N+2
	CALL Square

;--------------DIRCERTORIES-------------------

	MOV DH,6;-->COLUNA-1
	MOV DL,14;-->LINHA
	MOV CH,0;-->0 SE  PASTA
	MOV FilePos,0
	CALL WriteFiles


	MOV square_ini_X,100
	MOV square_ini_y,110
	MOV square_tam_X,120
	MOV square_tam_y,242	;16*N+2
	CALL Square
	MOV square_ini_X,220
	MOV square_ini_y,110
	MOV square_tam_X,15
	MOV square_tam_y,242	
	CALL Square

	MOV square_ini_X,220
	MOV square_ini_y,126
	MOV square_tam_X,15
	MOV square_tam_y,210	
	CALL Square


;--------------FILES-------------------
	MOV BL,62;-->COR
	MOV DH,6;-->COLUNA-1
	MOV DL,32;-->LINHA
	MOV CH,1;-->0 SE  PASTA
	MOV FilePos,0
	CALL WriteFiles


	MOV square_ini_X,245
	MOV square_ini_y,110
	MOV square_tam_X,120
	MOV square_tam_y,242	;16*N+1
	CALL Square
	MOV square_ini_X,365
	MOV square_ini_y,110
	MOV square_tam_X,15
	MOV square_tam_y,242	
	CALL Square

	MOV square_ini_X,365
	MOV square_ini_y,126
	MOV square_tam_X,15
	MOV square_tam_y,210	
	CALL Square
;--------------------------------------

;MOV CX,8
;MOV BX,110
;SquareLoop:
;	PUSH CX
;	MOV square_ini_X,50
;	MOV square_ini_y,BX
;	MOV square_tam_X,400
;	MOV square_tam_y,17
;	CALL Square
;	ADD BX,16
;	POP CX
;LOOP SquareLoop

mov ax,01	;mostrar rato
int 33h


	RET
IniGraficMode ENDP
;##########################################################
;##########################################################
IniEmissor PROC NEAR

	CALL IniGraficMode	;chama procedimento para desenhar o ambiente grafico

;---------motrar titulo do emissor-----------

	MOV AH,2
	MOV BX,62
	MOV DH,2;-->COLUNA
	MOV DL,12;-->LINHA
	INT 10h

	LEA DX,Sel_File
	MOV AH,09h
	INT 21h

;---------------------------------------------

	CALL EmissorMouse	;chama procedimento para o movimento do rato no emissor


	RET
IniEmissor ENDP

;##########################################################
;##########################################################
IniReceptor PROC NEAR

	CALL IniGraficMode	;chama procedimento para desenhar o ambiente grafico

;---------motrar titulo do receptor-----------

	MOV AH,2
	MOV BX,62
	MOV DH,2;-->COLUNA
	MOV DL,12;-->LINHA
	INT 10h

	LEA DX,Rec_File
	MOV AH,09h
	INT 21h

;--------------RECEIVE BUTTON----------------

	MOV AH,2
	MOV BX,62
	MOV DH,18;-->COLUNA
	MOV DL,53;-->LINHA
	INT 10h

	LEA DX,Receive
	MOV AH,09h
	INT 21h

	MOV square_ini_X,418
	MOV square_ini_y,280
	MOV square_tam_X,121
	MOV square_tam_y,27
	CALL Square

;---------------------------------------------

	CALL ReceptorMouse	;chama procedimento para o movimento do rato no receptor


	RET
IniReceptor ENDP
;##########################################################
;##########################################################
;##########################################################
;##########################################################
;##########################################################
;##########################################################
EmissorMouse PROC NEAR

getpos:



	MOV AX,5		;saber informaao dos butoes do rato
	MOV BX,0		;0-ESQ,1-DIR,2-CENT
	INT 33h


	AND AX,1b
	cmp ax,1b		;verifica se o boto esquerdo do rato foi primido
	jne getpos

	
	cmp bx,1		;verifica quantas vezes o buto foi precionado
	jB getpos

	CALL DirArea		;verifica-se o rato est na area de escolha de directoria
	CALL DirMoveArea	;verifica-se o rato est na area de movimento de directorias
	CALL FileMoveArea	;verifica-se o rato est na area de movimento de ficheiros
	CALL FileArea		;verifica-se o rato est na area de escolha de ficheiros
	CALL DriveArea		;verifica-se o rato est na area de escolha de drive

;----------verifica se o buto de regresso ao menu foi precionado

	cmp cx,418
	jl getpos
	cmp cx,539
	jg getpos
	cmp dx,232
	jl getpos
	cmp dx,258
	jg getpos

	RET

EmissorMouse ENDP
;##########################################################
;##########################################################
ReceptorMouse PROC NEAR

getpos2:



	MOV AX,5
	MOV BX,0	;0-ESQ,1-DIR,2-CENT
	INT 33h


	AND AX,1b
	cmp ax,1b	;verifica se o boto esquerdo do rato foi primido
	jne getpos2

	
	cmp bx,1	;verifica quantas vezes o buto foi precionado
	jB getpos2

	CALL DirArea		;verifica-se o rato est na area de escolha de directoria
	CALL DirMoveArea	;verifica-se o rato est na area de movimento de directorias
	CALL FileMoveArea	;verifica-se o rato est na area de movimento de ficheiros
	CALL DriveArea		;verifica-se o rato est na area de escolha de drive


;----------verifica se o buto de regresso ao menu foi precionado

	cmp cx,418
	jl getpos2
	cmp cx,539
	jg getpos2
	cmp dx,232
	jl getpos2
	cmp dx,258
	jg sendf


	RET


;----------verifica se o buto de recepcao de ficheiros foi precionado

sendf:

	cmp dx,280
	jl getpos2
	cmp dx,307
	jg getpos2

;----------altera titulo do receptor para mostar que est  espera de receber o ficheiro

	MOV AH,2
	MOV BX,62
	MOV DH,2;-->COLUNA
	MOV DL,12;-->LINHA
	INT 10h

	LEA DX,Receiving
	MOV AH,09h
	INT 21h

	CALL GetFileName	;procedimento para obter o nome do ficheiro a receber
	CALL WriteFile		;procedimento para guardar o ficheiro no disco



	RET

ReceptorMouse ENDP
;##########################################################
;##########################################################

ReadFile PROC NEAR		;l ficheiro a enviar

	;MOV Ax,02
	;INT 33h


	MOV AL,0
	OPENRFILE	;abrir ficheiro de leitura

	SEEK_BEG	;colocar posiao do ficheiro no inicio


;-------saber num de partes de 500 bytes a enviar-------------

MOV NPart_Send,0
GetNumSend:


	MOV AL,01H
	MOV AH,42H
	MOV BX,RFHAND
	XOR CX,CX
	MOV DX,499		; avana posiao do ficheiro 500 bytes
	INT 21H
	INC NPart_Send		;incrementar numero de partes a enviar


	MOV AH,3FH		; prepara a leitura no ficheiro
	MOV BX,RFHAND		; coloca em BX o file handle
	MOV CX,1		; ler um byte do ficheiro
	LEA DX,Buffer		; aponta para o buffer de dados
	INT 21H

test ax,ax
jnz GetNumSend		;testar se j se chegou ao final do ficheiro

;--------------------------------------------------------------

SEEK_BEG	;colocar posiao do ficheiro no inicio


;-----------mostrar Tamanho aproximado do fich. (usado 1000bytes em vez de 1024bytes)

XOR DX,DX
MOV AX,NPart_Send
MOV BX,2
DIV BX			;divide por 2 para dar o numero de Kbytes
MOV CH,5
CALL NUM2STR		;procedimento para converter o valor de ax em string
	MOV AH,2
	MOV BX,62
	MOV DH,28;-->COLUNA
	MOV DL,5;-->LINHA
	INT 10h
MOV NBar[5],' '
MOV NBar[6],'k'
MOV NBar[7],'b'
MOV NBar[8],'$'
	LEA DX,NBar	;mostrar o tamanho aproximado od ficheiro
	MOV AH,09h
	INT 21h

;--------------------------------------------

CALL SendFileName	;mandar o nome e numero de partes do ficheiro a ler para o receptor


;-----------mostrar numero de vezes a enviar 500bytes do fich.

MOV AX,NPart_Send
MOV CH,5
CALL NUM2STR		;procedimento para converter o valor de ax em string
	MOV AH,2
	MOV BX,62
	MOV DH,26;-->COLUNA
	MOV DL,63;-->LINHA
	INT 10h
MOV NBar[5],' '
MOV NBar[6],'('
MOV NBar[7],'$'
	LEA DX,NBar	;mostrar o numero de partes(de 500bytes) a ler do ficheiro
	MOV AH,09h
	INT 21h


;-----------------loop para enviar 500bytes do fich. de cada vez

MOV CX,NPart_Send
mov Parts,0

Sendfile:
PUSH CX

	MOV AH,3FH		; prepara a leitura no ficheiro
	MOV BX,RFHAND		; coloca em BX o file handle
	MOV CX,500		; numero de bytes a ler
	LEA DX,Buffer+2		; aponta para o buffer de dados
	INT 21H

	MOV Buffer[0],AH	;nas primeiras posicoes do buffer vo
	MOV Buffer[1],AL	;o numero de bytes lidos do ficheiro

call SENDSTRING			;envia o buffer de 500bytes para o receptor

INC Parts			;conta o numero de vezes enviado o buffer



;----------------mostar barra e percentagem-----------------

CALL percent

;--------------------mostrar o numero de vezes que j enviou 500bytes

MOV AX,Parts
MOV CH,5
CALL NUM2STR		;procedimento para converter o valor de ax em string
	MOV AH,2
	MOV BX,62
	MOV DH,26;-->COLUNA
	MOV DL,57;-->LINHA
	INT 10h

MOV NBar[5],'\'

	LEA DX,NBar	;mostrar o numero numero de vezes que j enviou 500bytes
	MOV AH,09h
	INT 21h

POP CX
LOOP Sendfile



	MOV AH,02
	MOV DH,26;-->COLUNA
	MOV DL,5;-->LINHA
	INT 10h


	MOV Buffer[0],0
	MOV Buffer[1],0		;envia um buffer com 0 bytes lidos do
	call SENDSTRING		;ficheiro para o receptor saber que acabou de receber o ficheiro

;-----------------------------limpar barra


	MOV AH,09h
	MOV AL,' '
	MOV BH,0
	MOV BL,Cor
	MOV CX,50	;preence a barra com os caracters em branco
	INT 10h


CLOSERFILE		;fecha o ficheiro



;MOV Ax,01
;INT 33h

	RET

ReadFile ENDP
;##########################################################
;##########################################################
SENDSTRING PROC NEAR


       SUB BX,BX
  
REPETE_E:
       MOV AL,Buffer[BX]	;envia cada byte do buffer
       CMP BX,502		;at chegar ao 502 bytes[(2 para caracters lidos)+(500 para informacao)]
       je  TERMINA_E
  
       INC BX

       mov  dx,3F8h+5
       push ax

ESPERA_E:

       IN   AL,DX
       test al, 00100000b 	;verifica se o buffer da com est limpo
       JZ ESPERA_E         	;caso contrario espera que esteja
          
       MOV  DX,3F8h  		;Prepara o Porto RS232 COM1 Para receber o caracter
       POP  AX
   
       OUT  DX,AL
       jmp  REPETE_E

TERMINA_E:			;termina envio do buffer de caracters


ret
SENDSTRING endp

;##########################################################
;##########################################################
WriteFile PROC NEAR	;escrita do ficheiro recebido pelo receptor

CREATEFILE		;cria um ficheiro
OPENWFILE		;e abre este para escrita


mov bx,0		;inicializa a posiao onde se comea a escrever no buffer de caracters recebidos
mov Parts,0
jmp REPETE_R

NOVO_BUFFER:



mov ch,buffer[0]	;carrega o numero de caracteres a escrever no ficheiro
mov cl,buffer[1]	;(nota: na primeira posiao de cada buffer  enviado o n de caracters lidos)
MOV BX,CX
ADD BX,2
mov buffer[BX],'$'
mov ch,buffer[0]
mov cl,buffer[1]


;mov ah,09h
;lea dx,Buffer
;int 21h



          MOV AH,40H		; prepara a escrita no ficheiro
	  MOV BX,WFHAND		; coloca em BX o file handle


	  LEA DX,Buffer+2		; aponta para o buffer de dados
	  INT 21H



cmp cx,0	;verifica se j se chegou ao final do ficheiro
JE TERMINA_R



INC Parts	;conta o numero de vezes que se recebeu 500bytes do ficheiro

;----------------mostar barra e percentagem-----------------
CALL percent


       MOV BX,0	;reinicia a posicao de escrita no buffer de caracters recebidos


REPETE_R:


       CMP  BX,502		;verifica se j recebeu os 502 caractes
       JE   NOVO_BUFFER		;e depois guarda os 500bytes de caractes recebidos

 

       MOV  DX,3F8h+5
       PUSH AX


ESPERA_R:
       IN   AL,DX

       TEST AL, 1   	;verifica se existe informaao
       JZ ESPERA_R    	;espera que exista alguma coisa a receber
     
       MOV  DX,3F8h  	;Prepara o Porto RS232 COM1 Para receber o caracter
       POP  AX
   
       IN   AL,DX

       MOV  Buffer[BX],AL	;guarda o caracter recebido no buffer
       INC  BX       		;Incrementa o contador
       JMP  REPETE_R

TERMINA_R:			;terminada a recepcao do ficheiro


CLOSEWFILE			;fechar ficheiro de escrita


	RET
WriteFile ENDP
;##########################################################
;##########################################################
SendFileName PROC NEAR

MOV AX,NPart_Send	;envio do numero de partes a receber
MOV FileName[13],AH	;nas posicoes 13 e 14
MOV FileName[14],AL


       SUB BX,BX
  
REPETE_E2:
       MOV AL,FileName[BX]	;envia cada byte de 'FileName'
       CMP BX,15		;at chegar ao 15 bytes[(13 para o nome do ficheiro)+(2 para numero de partes)]
       je  TERMINA_E2
  
       INC BX

       mov  dx,3F8h+5
       push ax

ESPERA_E2:

       IN   AL,DX
       test al, 00100000b 	;verifica se o buffer da com est limpo
       JZ ESPERA_E2         	;caso contrario espera que esteja
          
       MOV  DX,3F8h  		;Prepara o Porto RS232 COM1 Para receber o caracter
       POP  AX
   
       OUT  DX,AL
       jmp  REPETE_E2

TERMINA_E2:


ret
SendFileName endp

;##########################################################
;##########################################################
GetFileName PROC NEAR

mov bx,0

REPETE_R2:


       CMP  BX,15	;verifica se j foram recebido todos o bytes para saber o nome do fich
       JE   TERMINA_R2
 

       MOV  DX,3F8h+5
       PUSH AX




ESPERA_R2:
       IN   AL,DX

       TEST AL, 1   	;verifica se existe informaao
       JZ ESPERA_R2    	;espera que exista alguma coisa a receber
     
       MOV  DX,3F8h  	;Prepara o Porto RS232 COM1 Para receber o caracter
       POP  AX
   
       IN   AL,DX

       MOV  FileName[BX],AL	;guarda o caracter recebido em 'FileName'
       INC  BX      		 ;Incrementa o contador
       JMP  REPETE_R2

TERMINA_R2:			;terminada a recepcao do nome ficheiro



mov ah,FileName[13]	;guarda o numero de partes (posicao 13 e 14)
mov al,FileName[14]	;que vao ser enviadas na 
mov NPart_Send,ax	;variavel 'NPart_Send'

mov dh,0
	CALL AddFile	;adiciona o nome do ficheiro ao caminho escolhido
	CALL WritePath	;escreve caminho do ficheiro de destino no ecr

;-----------mostrar numero de vezes a receber 500bytes do fich.

MOV AX,NPart_Send
MOV CH,5
CALL NUM2STR
	MOV AH,2
	MOV BX,62
	MOV DH,26;-->COLUNA
	MOV DL,63;-->LINHA
	INT 10h
MOV NBar[5],' '
MOV NBar[6],'('
MOV NBar[7],'$'
	LEA DX,NBar
	MOV AH,09h
	INT 21h


	RET
GetFileName ENDP


;##########################################################
;##########################################################
;##########################################################
;##########################################################
Percent PROC NEAR

;-----------------------------calcula percentagem atraves de
;uma regra de 3 simples

MOV AX,Parts
MOV BX,100
MUL BX
MOV BX,NPart_Send
DIV BX
PUSH AX			;percentagem guardada em AX

;-------------------calcula posio at onde deve ir a barra
;---------------e desenha esta

XOR DX,DX
MOV BX,2
DIV BX

TEST AX,AX	;verifica se se vai em 0%
JZ ShowPerc	;se sim no se mostra a barra



CMP NPart_Send,50
JNG LBar
;-------------------verifica se o ficheiro  grande e s desenha ultimo caracter da barra
	MOV Dx,ax
	add dx,4
	MOV AH,2
	MOV BX,0
	MOV DH,26;-->COLUNA
	INT 10h

		MOV AL,219
		CALL WriteChar

JMP ShowPerc

;-------------------se o ficheiro for pequeno desenha-se todos os caracter da barra
LBar:


	MOV CX,AX

	MOV AH,02
	MOV DH,26;-->COLUNA
	MOV DL,5;-->LINHA
	INT 10h

;--------------escreve o caracter at chegar a posio da barra

	MOV AH,09h
	MOV AL,219
	MOV BH,0
	MOV BL,Cor

	INT 10h



ShowPerc:
POP AX

;-----------------mostrar a percentagem de envio do ficheiro

MOV CH,3
CALL NUM2STR
	MOV AH,2
	MOV BX,62
	MOV DH,26;-->COLUNA
	MOV DL,70;-->LINHA
	INT 10h

MOV NBar[3],'%'
MOV NBar[4],')'
MOV NBar[5],'$'

	LEA DX,NBar
	MOV AH,09h
	INT 21h


	RET
Percent ENDP
;##########################################################
;##########################################################
;##########################################################
;##########################################################

DirArea PROC NEAR

;-----verifica se o rato est na rea de directorias--------

	cmp cx,100
	jl end_dir

	cmp cx,220
	jg end_dir

	cmp dx,110
	jl end_dir

	cmp dx,351
	jg end_dir

;-----------procura a posicao do rato dentro da area----------

MOV BX,110		;directorias comeam a ser escritos na coluna 110
MOV AL,0
FindDirPos:
	INC AL		;incrementa-se AL at saber a posicao do directoria onde t o rato
	ADD BX,16	;cada directoria ocupa uma altura de 16
	CMP DX,BX	;verifica-se se o rato est acima da posicao a pesquisar

JNL FindDirPos		;se estiver ento foi achada a posicao do rato

	CMP AL,DirNum	;se a posicao for maior que o numero de directoria existentes
	JG end_dir	; porque no existe uma directoria valida naquela posicao


	MOV FilePos,AL
	CALL WriteFiles	;vai buscar o nome da directoria naquela posicao


	CMP FileName[0],'.'	;verifica se o nome da directoria comea por '.'
	JNE AddD		;se no  porque  uma directoria

	CMP FileName[1],'.'	;verifica se o nome da directoria  '..'
	JE RmD			;se sim ento volta a directoria anterior

	;CALL GetCurPath
	JMP ShowPath


AddD:

	CALL AddDir		;adiciona uma directoria
	JMP ShowPath

RmD:

	CALL RmDir		;volta a directoria anterior

ShowPath:

	CALL WritePath		;escreve caminho


mov ax,02h			;esconde o rato
int 33h

	MOV DH,6;-->COLUNA-1
	MOV DL,14;-->LINHA
	CALL ClearFiles		;limpa todas as directorias do ecra

	MOV DH,6;-->COLUNA-1
	MOV DL,14;-->LINHA
	MOV CH,0;-->0 SE  PASTA
	MOV FilePos,0		;para saber que no se est  procura de ficheiros
	MOV DirStart,0		;inicia a posicao das directorias
	MOV FileStart,0		;inicia a posicao dos ficheiros
	CALL WriteFiles		;escreve novas directorias dentro da dir selecionada


	MOV DH,6;-->COLUNA-1
	MOV DL,32;-->LINHA
	CALL ClearFiles		;limpa todos os ficheiros do ecra

	MOV DH,6;-->COLUNA-1
	MOV DL,32;-->LINHA
	MOV CH,1;-->0 SE  PASTA
	CALL WriteFiles		;escreve novos ficheiros dentro da dir selecionada

end_dir:
mov ax,01h			;mostra o rato
int 33h

	RET

DirArea ENDP

;##########################################################
;##########################################################

FileArea PROC NEAR

;-----verifica se o rato est na rea de ficheiros--------

	cmp cx,245
	jl end_file

	cmp cx,365
	jg end_file

	cmp dx,110
	jl end_file

	cmp dx,351
	jg end_file

;-----------procura a posicao do rato dentro da area----------

MOV BX,110		;ficheiros comeam a ser escritos na coluna 110
MOV AL,0
FindFilePos:
	INC AL		;incrementa-se AL at saber a posicao do ficheiro onde t o rato
	ADD BX,16	;cada ficheiro ocupa uma altura de 16
	CMP DX,BX	;verifica-se se o rato est acima da posicao a pesquisar

JNL FindFilePos		;se estiver ento foi achada a posicao do rato

	CMP AL,FileNum	;se a posicao for maior que o numero de ficheiros existentes
	JG end_dir	; porque no existe um ficheiro valido naquela posicao


	MOV FilePos,AL
	CALL WriteFiles	;vai buscar o nome do ficheiro naquela posicao


mov dh,0
	CALL AddFile	;adiciona esse ficheiro ao caminho
	CALL WritePath	;escreve o caminho

CALL ReadFile		;esvia o ficheiro selecionado



CALL RmDir		;revover o ficheiro do caminho depois de ser enviado
	CALL WritePath	;escreve o caminho


end_file:

	RET

FileArea ENDP
;##########################################################
;##########################################################

DriveArea PROC NEAR

;-----verifica se o rato est na rea de drives--------

	cmp cx,37
	jl end_drive

	cmp cx,84
	jg end_drive

	cmp dx,110
	jl end_drive

	cmp dx,351
	jg end_drive

;-----------procura a posicao do rato dentro da area----------

MOV BX,110		;drives comeam a ser escritos na coluna 110
MOV AL,0
FindDrivePos:
	INC AL		;incrementa-se AL at saber a posicao da drive onde t o rato
	ADD BX,16	;cada drive ocupa uma altura de 16
	CMP DX,BX	;verifica-se se o rato est acima da posicao a pesquisar

JNL FindDrivePos		;se estiver ento foi achada a posicao do rato

	CMP AL,10	;compara-se se no est a ultrapassar o numero de 10 drives existentes
	JG end_drive

DEC AL			;decrementa-se al para se saber o numero da drive correctamente


	CALL AddDrive	;poe-se a drive no caminho


	CALL WritePath	;escreve o caminho


mov ax,02h	;esconde o rato
int 33h

	MOV DH,6;-->COLUNA-1
	MOV DL,14;-->LINHA
	CALL ClearFiles		;limpa todas as directorias do ecra

	MOV DH,6;-->COLUNA-1
	MOV DL,14;-->LINHA
	MOV CH,0;-->0 SE  PASTA
	MOV FilePos,0		;para saber que no se est  procura de ficheiros
	MOV DirStart,0		;inicia a posicao das directorias
	MOV FileStart,0		;inicia a posicao dos ficheiros
	CALL WriteFiles		;escreve novas directorias dentro da drive selecionada


	MOV DH,6;-->COLUNA-1
	MOV DL,32;-->LINHA
	CALL ClearFiles		;limpa todos os ficheiros do ecra

	MOV DH,6;-->COLUNA-1
	MOV DL,32;-->LINHA
	MOV CH,1;-->0 SE  PASTA
	CALL WriteFiles		;escreve novos ficheiros dentro da drive selecionada

end_drive:
mov ax,01h	;mostra o rato
int 33h

DriveArea ENDP

;##########################################################
;##########################################################
DirMoveArea PROC NEAR

;-----verifica se o rato est na rea de mover directorias para baixo--------

	cmp cx,220
	jl end_dirm

	cmp cx,230
	jg end_dirm

	cmp dx,336
	jl dmoveup

	cmp dx,351
	jg dmoveup


MOV AH,DirNum
CMP AH,15	;saber se o numero de directorias  suficiente para mover
JNG end_dirm

SUB AH,15
CMP AH,DirStart	;saber se se poder baixar mais o num de directorias
JNG end_dirm

INC DirStart	;se se puder ento incrementa-se a posicao de comecar a escrever directorias
JMP show_dirm



dmoveup:
;-----verifica se o rato est na rea de mover directorias para cima--------


	cmp dx,110
	jl end_dirm

	cmp dx,126
	jg end_dirm


MOV AH,DirNum
CMP AH,15	;saber se o numero de directorias  suficiente para mover
JNG end_dirm

MOV AH,DirStart
CMP AH,0	;saber se se poder levantar mais o num de directorias
JNG end_dirm

DEC DirStart	;se se puder ento decrementa-se a posicao de comecar a escrever directorias


show_dirm:

	MOV DH,6;-->COLUNA-1
	MOV DL,14;-->LINHA
	CALL ClearFiles		;limpa todas as directorias do ecra

	MOV DH,6;-->COLUNA-1
	MOV DL,14;-->LINHA
	MOV CH,0;-->0 SE  PASTA
	MOV FilePos,0
	CALL WriteFiles		;escreve nova lista de directorias actualizada


end_dirm:

	RET

DirMoveArea ENDP
;##########################################################
;##########################################################

FileMoveArea PROC NEAR

;-----verifica se o rato est na rea de mover ficheiros para baixo--------

	cmp cx,365
	jl end_filem

	cmp cx,375
	jg end_filem

	cmp dx,336
	jl fmoveup

	cmp dx,351
	jg fmoveup


MOV AH,FileNum
CMP AH,15	;saber se o numero de ficheiros  suficiente para mover
JNG end_filem

SUB AH,15
CMP AH,FileStart	;saber se se poder baixar mais o num de ficheiros
JNG end_filem

INC FileStart	;se se puder ento incrementa-se a posicao de comecar a escrever ficheiros
JMP show_filem

fmoveup:
;-----verifica se o rato est na rea de mover ficheiros para cima--------

	cmp dx,110
	jl end_filem

	cmp dx,126
	jg end_filem


MOV AH,FileNum
CMP AH,15	;saber se o numero de ficheiros  suficiente para mover
JNG end_filem

MOV AH,FileStart
CMP AH,0	;saber se se poder levantar mais o num de ficheiros
JNG end_filem

DEC FileStart	;se se puder ento decrementa-se a posicao de comecar a escrever ficheiros


show_filem:

	MOV DH,6;-->COLUNA-1
	MOV DL,32;-->LINHA
	CALL ClearFiles		;limpa todos os ficheiros do ecra

	MOV DH,6;-->COLUNA-1
	MOV DL,32;-->LINHA
	MOV CH,1;-->0 SE  PASTA
	MOV FilePos,0
	CALL WriteFiles		;escreve nova lista de ficheiros actualizada


end_filem:

	RET

FileMoveArea ENDP
;##########################################################
;##########################################################
;##########################################################
;##########################################################

WritePath PROC NEAR

;----------------limpar o caminho com espacos em branco-------

	MOV AH,02
	MOV DH,23;-->COLUNA
	MOV DL,11;-->LINHA
	INT 10h

	MOV AH,09h
	MOV AL,' '
	MOV BH,0
	MOV BL,Cor
	MOV CX,100
	INT 10h

;----------------escrever o caminho-------


	MOV AH,2
	MOV BX,0
	MOV DH,23;-->COLUNA
	MOV DL,11;-->LINHA
	INT 10h

	LEA DX,Path
	MOV AH,09h
	INT 21h


	RET

WritePath ENDP

;##########################################################
;##########################################################

WriteChar PROC NEAR
	;ESCREVE CARACTER COM ULTIMO ATRIBUTO E REPOSICIONA CURSOR
;(ENTRADA)
;AL-->CARACTER
	PUSH BX
	
	MOV AH,0EH
	MOV BH,0
	MOV BL,Cor
	INT 10H

	POP BX
	RET

WriteChar ENDP


;##########################################################
;##########################################################

WriteDrives PROC NEAR
;(ENTRADA)
;DH-->COLUNA-1
;DL-->LINHA

MOV AL,'A'
MOV CX,10
wd:		;loop para escrever as primeirras 10 drives

	MOV AH,02
	INC DH;-->COLUNA
	;MOV DL,Linha
	INT 10h

	CALL WriteChar

	INC AL	;avancar com o numero de drives

LOOP wd

	RET
WriteDrives ENDP

;##########################################################
;##########################################################

ClearFiles PROC NEAR
;(ENTRADA)
;DH-->COLUNA-1
;DL-->LINHA



MOV CX,15	;limpar todos so 15 ficheiros
ClearRow:


	MOV AH,02
	INC DH;-->COLUNA
	;MOV DL,Linha
	INT 10h



	PUSH CX
	MOV AH,09h
	MOV AL,' '
	MOV BX,53
	MOV CX,13	;escrever linha de 13 espacos em branco
	INT 10h		;para limpar o ficheiro
	POP CX



LOOP ClearRow


	RET
ClearFiles ENDP

;##########################################################
;##########################################################
;##########################################################
;##########################################################

WriteFiles PROC NEAR

;(ENTRADA)
;DH-->COLUNA-1
;DL-->LINHA
;CH-->0 SE  PASTA
;FilePos-->SE FILE FilePos >0 ENTO PROCURA POSIAO E GRAVA EM FILENAME


MOV CountFiles,0

	TEST CH,CH
JZ ResetDir

	MOV FileNum,0	;limpa numero de ficheiros na directoria
JMP FindFirst

ResetDir:
	MOV DirNum,0	;limpa numero de pastas na directoria


FindFirst:

	PUSH DX

	MOV AH,1Ah
	LEA DX,DTA	;seleciona "Disk Transfer Address" para gravao de informaes dos ficheiros
	INT 21h
	MOV CL,10000b	;atributos dos ficheiros a procurar


	LEA DX,Path	;caminho da directoria a procurar os ficheiros
	MOV AH,4EH
	INT 21h

	POP DX
	jc NoMoreFiles	;se no encontar ficheiros na directoria ento sai



DirLoop:

	TEST CH,CH	;verifica se o que se procura so ficheiros ou pastas
JZ Dir

;-------------------------------SE FOR FICHEIRO

TEST DTA[21],10000b	;verifica se o que foi encontrado foi um ficheiro
JNZ NextEntry		;se no for ento vai procurar no seguinte

	INC FileNum	;comea a contar os ficheiros

	MOV CL,FileNum
	CMP CL,FileStart	;verifica a posicao que comeca a escrever os ficheiros
	JNG NextEntry

	;;;;;call GetFileSize
JMP verif

;----------------------------------------------


Dir:
;-------------------------------SE FOR PASTA

TEST DTA[21],10000b	;verifica se o que foi encontrado foi uma directoria
JZ NextEntry		;se no for ento vai procurar no seguinte

	INC DirNum	;comea a contar as directorias encontradas

	MOV CL,DirNum
	CMP CL,DirStart	;verifica a posicao que comeca a escrever as directorias
	JNG NextEntry
;----------------------------------------------


verif:
	LEA SI,DTA+30      ;endereco do nome do ficheiro
	CLD

	MOV AH,02
	INC DH;-->COLUNA	;incrementa acoluna em que escreve o seguinte ficheiro
	INT 10h



INC CountFiles;--->CONTA FICHEIROS ESCRITOS
MOV CL,CountFiles
CMP CL,15		;verifica se j foram escritos o numero maximo de ficheiros
JG NextEntry


MOV BX,0
PrtName:

	LODSB


	TEST AL,AL         ;Zero byte?
	JZ NextEntry		;verifica se j se chegou ao final do nome do ficheiro

	CMP FilePos,0		;se se tiver a procurar um nome de ficheiro salta-se
	JNE WFile


	CALL WriteChar          ;mostra caracter do ficheiro



JMP PrtName

WFile:
	CMP CL,FilePos		;verifica se esta  a posicao do ficheiro que se procurava
	JNE NextEntry
	MOV FileName[BX],AL	;move o caracter do ficheiro encontrado
	INC BX
	MOV FileName[BX],0	;finaliza o nome do ficheiro mesmo que se adicione mais caracteres

JMP PrtName

NextEntry:




	MOV AH,4FH         ;encontrar proximo ficheiro
	INT 21h



	JNC DirLoop

NoMoreFiles:	;no exitem mais ficheiros no caminho


	RET
WriteFiles ENDP

;##########################################################
;##########################################################
GetFileSize PROC NEAR;??????????????????	

	PUSH BX
	PUSH CX
	LEA SI,DTA+27      ;Address of filename
	;CLD
	STD


	MOV CX,2
	GetSize: 
		LODSB
		OR BL,AL 	; GUARDA O DIGITO HEX NO REGISTO
		;MOV FileSize,BX
		SHL BX,01h	; FAZ 4 VEZES O O SHIFT DE 1 BIT
		SHL BX,01h	; PARA A ESQUERDA
		SHL BX,01h	
		SHL BX,01h	
		SHL BX,01h	; FAZ 4 VEZES O O SHIFT DE 1 BIT
		SHL BX,01h	; PARA A ESQUERDA
		SHL BX,01h	
		SHL BX,01h	
	LOOP GetSize
	POP CX
	POP BX

	RET
GetFileSize ENDP
;##########################################################
;##########################################################
;##########################################################
;##########################################################

Square PROC NEAR	;nome do procedimento para quadrados

;(ENTRADA)
;square_ini_X-->posio x onde comea a ser desenhado o quadrado
;square_ini_y-->posio y onde comea a ser desenhado o quadrado
;square_tam_X-->tamanho do quadrado na horizontal
;square_tam_y-->tamanho do quadrado na vertical
;CorRect-->usado para saber a cor com que se desenha os quadrados
;------------------------------------------------------------------

   MOV CX,square_tam_X		;designa a largura do quadrado
   coluna:			;etiqueta coluna que serve para correr todos os pixeis da linha
      PUSH CX			;guarda valor de CX do loop na pilha
      MOV DX,square_tam_y	;designa valor da altura do quadrado
      mov CX,DX			;guarda valor da altura em cx para fazer o loop

      linha:			;etiqueta linha para percorrer todos os pixeis da coluna

         MOV DX,CX		;guarda valor da linha a usar em dx
         POP CX			;carrega o valor da coluna a usar para desenhar o pixel

cmp dx,1
je a
cmp dx,square_tam_Y
je a
cmp cx,1
je a
cmp cx,square_tam_X
je a
jmp b
a:
	 
         ADD CX,square_ini_X	;posiao x onde vai comear a ser desenhado o quadrado
         ADD DX,square_ini_y	;posiao y onde vai comear a ser desenhado o quadrado

         MOV AL,CorRect 		; cor dos pontos verde, configura
         MOV AH,12 		; configura INT10h para plot do pixel
         INT 10h 		; invoca a interrupo 10h da BIOS

         SUB CX,square_ini_X	;volta a carregar o valor original de cx
         SUB DX,square_ini_y	;volta a carregar o valor original de dx
b:

         PUSH CX		;guarda o valor da conula na pilha
         mov CX,DX		;carrega valor da linha em cx para continuar com o loop
      LOOP linha		;salta para a etiqueta "linha" at cx igual a 0

   POP CX			;carrega o valor da coluna que foi guardado
   loop coluna			;salta para a etiqueta "coluna" at cx igual a 0


RET				;volta ao programa

Square ENDP

;##########################################################
;##########################################################
;##########################################################
;##########################################################

NUM2STR  PROC    NEAR	         ; nome do procedimento MYPROC

;(ENTRADA)
;AX numero a converter
;CH numero de digitos


;CMP AX,0



MOV CL,0

cvn:

	MOV BX,10
	XOR DX,DX
	CMP AX,0
	;JE cvnend
	JE d0		;se for encontrado um 0 no divide

	DIV BX		;divide por 10 e apanha o resto

	d0:
	PUSH DX

	ADD CL,1	;conta numero de vezes que achou um numero

	CMP CL,CH
	JE cvnend

JMP cvn	
cvnend:



MOV BX,0
MOV CH,0

put:
	POP DX
	ADD DL,48	;converte numero para ascii
	;MOV AH,02
	;INT 21H
	MOV NBar[BX],DL	;guarda-o na string
	INC BX
LOOP put

MOV CH,BL
	MOV NBar[6],'$'

;(SAIDA)
;CH posIco onde acabou de escrever no array

RET
NUM2STR ENDP

;##########################################################
;##########################################################

MYCODE ENDS				; fim do codigo
END 				; FIM de todo o programa
end



